#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/exec.h>
#include <proto/intuition.h>
#include <proto/graphics.h>

extern struct TextAttr textAttr;

USHORT chip gImageData[2][48] = {
  {0x0000, 0x0000, 0x0000, 0x0001,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x0000, 0x0000, 0x0000, 0x0003,
   0x7fff, 0xffff, 0xffff, 0xffff},
   
  {0xffff, 0xffff, 0xffff, 0xfffe,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0xc000, 0x0000, 0x0000, 0x0000,
   0x8000, 0x0000, 0x0000, 0x0000}
};

struct Image gImage = {
   0,0, 64, 12, 2,
   (USHORT *)gImageData,0x0003,0x00000,NULL
};

struct IntuiText exitText = {
   1,0, JAM2, 15,2, &textAttr, "Quit", NULL
};
struct IntuiText infoText = {
   1,0, JAM2, 15,2, &textAttr, "Info", NULL
};
struct IntuiText fileText = {
   1,0, JAM2, 15,2, &textAttr, "File", NULL
};
struct IntuiText paletteText = {
   1,0, JAM2, 5,2, &textAttr, "Palette",NULL
};
struct IntuiText screenText = {
   1,0, JAM2, 9,2, &textAttr, "Screen", NULL
};

struct Gadget screenGadget = {NULL, 306,6, 64,12, GADGHCOMP|GADGIMAGE|GADGDISABLED,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &screenText, NULL, NULL,
   50, NULL
};
struct Gadget paletteGadget = {&screenGadget, 232,6, 64,12, GADGHCOMP|GADGIMAGE|GADGDISABLED,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &paletteText, NULL, NULL,
   40, NULL
};
struct Gadget fileGadget = {&paletteGadget, 158,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &fileText, NULL, NULL,
   30, (APTR)1
};
struct Gadget infoGadget = { &fileGadget, 84,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &infoText, NULL, NULL,
   20, (APTR)1
};   
struct Gadget exitGadget = { &infoGadget, 10,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &exitText, NULL, NULL,
   10, (APTR)1
};
 
struct IntuiText openText = {
   1,0, JAM2, 15,2, &textAttr, "Open", NULL
};
struct IntuiText nextText = {
   1,0, JAM2, 15,2, &textAttr, "Next", NULL
};
struct IntuiText psText = {
   1,0, JAM2, 7,2, &textAttr, "SavePS", NULL
};
struct IntuiText iffText = {
   1,0, JAM2, 3,2, &textAttr, "SaveIFF", NULL
};
struct IntuiText mainText = {
   1,0, JAM2, 15,2, &textAttr, "Main", NULL
};

struct Gadget mainGadget = {NULL,     560,6,  64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &mainText, NULL, NULL,
   35, (APTR)1
};
struct Gadget psGadget = {&mainGadget, 232,6, 64,12, GADGHCOMP|GADGIMAGE|GADGDISABLED,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &psText, NULL, NULL,
   34, NULL
};
struct Gadget iffGadget = {&psGadget, 158,6, 64,12, GADGHCOMP|GADGIMAGE|GADGDISABLED,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &iffText, NULL, NULL,
   33, NULL
};
struct Gadget nextGadget = { &iffGadget, 84,6, 64,12, GADGHCOMP|GADGIMAGE|GADGDISABLED,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &nextText, NULL, NULL,
   32, NULL
};   
struct Gadget openGadget = { &nextGadget, 10,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &openText, NULL, NULL,
   31, (APTR)1
};
 
struct IntuiText loresText = {
   1,0, JAM2, 5,2, &textAttr, "LORES", NULL
};
struct IntuiText laceText = {
   1,0, JAM2, 5,2, &textAttr, "LACE", NULL
};
struct IntuiText hiresText = {
   1,0, JAM2, 5,2, &textAttr, "HIRES", NULL
};
struct IntuiText hilaceText = {
   1,0, JAM2, 5,2, &textAttr, "HILACE", NULL
};
struct IntuiText HEText = {
   1,0, JAM2, 9,2, &textAttr, "Ham-E", NULL
};
struct IntuiText HElaceText = {
   1,0, JAM2, 3,2, &textAttr, "HE Lace", NULL
};

struct Gadget main2Gadget = {NULL,     560,6,  64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &mainText, NULL, NULL,
   57, (APTR)1
};
struct Gadget HElaceGadget = {&main2Gadget, 380,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &HElaceText, NULL, NULL,
   56, (APTR)1
};
struct Gadget HEGadget = {&HElaceGadget, 306,6, 64,12,GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &HEText, NULL, NULL,
   55, (APTR)1
};
struct Gadget hilaceGadget = {&HEGadget, 232,6, 64,12,GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &hilaceText, NULL, NULL,
   54, (APTR)1
};
struct Gadget hiresGadget = {&hilaceGadget, 158,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &hiresText, NULL, NULL,
   53, (APTR)1
};
struct Gadget laceGadget = { &hiresGadget, 84,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &laceText, NULL, NULL,
   52, (APTR)1
};   
struct Gadget loresGadget = { &laceGadget, 10,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &loresText, NULL, NULL,
   51, (APTR)1
};

struct IntuiText showText = {
   1,0, JAM2, 15,2, &textAttr, "Show", NULL
};
struct IntuiText saveText = {
   1,0, JAM2, 13,2, &textAttr, "Save", NULL
};
struct IntuiText loadText = {
   1,0, JAM2, 15,2, &textAttr, "Load", NULL
};
UBYTE redbuf[4] = {' ',' ','0','\0'};
UBYTE greenbuf[4] = {' ',' ','0','\0'};
UBYTE bluebuf[4] = {' ',' ','0','\0'};
struct IntuiText rvText = {
   3,0, JAM2, 276,0, &textAttr, redbuf,NULL
};
struct IntuiText gvText = {
   3,0, JAM2, 276,0,&textAttr, greenbuf,NULL
};
struct IntuiText bvText = {
   3,0, JAM2, 276,0, &textAttr, bluebuf,NULL
};
struct IntuiText redText = {
   3,0, JAM2, -8, 0, &textAttr, "R", &rvText
};
struct IntuiText greenText = {
   3,0, JAM2, -8, 0, &textAttr, "G", &gvText
};
struct IntuiText blueText = {
   3,0, JAM2, -8, 0, &textAttr, "B", &bvText
};
struct PropInfo bpi = {
   AUTOKNOB|FREEHORIZ, 0x0000, 0x0000, MAXBODY/16, MAXBODY,
   0, 0, 0, 0, 0, 0 
};
struct PropInfo gpi = {
   AUTOKNOB|FREEHORIZ, 0x0000, 0x0000, MAXBODY/16, MAXBODY,
   0, 0, 0, 0, 0, 0 
};
struct PropInfo rpi = {
   AUTOKNOB|FREEHORIZ, 0x0000, 0x0000, MAXBODY/16, MAXBODY,
   0, 0, 0, 0, 0, 0 
};
struct Image GImage,RImage,BImage;
   
struct Gadget main3Gadget = {NULL,     560,6,  64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &mainText, NULL, NULL,
   44, (APTR)1
};
struct Gadget bpropGadget = {&main3Gadget, 242,27, 272,7,
   GADGHCOMP|GADGIMAGE, GADGIMMEDIATE|RELVERIFY, PROPGADGET, (APTR)&BImage, NULL,
   &blueText, NULL, (APTR)&bpi, 92, (APTR)1
};
struct Gadget gpropGadget = {&bpropGadget, 242,19, 272,7,
   GADGHCOMP|GADGIMAGE, GADGIMMEDIATE|RELVERIFY, PROPGADGET, (APTR)&GImage, NULL,
   &greenText, NULL, (APTR)&gpi, 91, (APTR)1
};
struct Gadget rpropGadget = {&gpropGadget, 242,11, 272,7,
   GADGHCOMP|GADGIMAGE, GADGIMMEDIATE|RELVERIFY, PROPGADGET, (APTR)&RImage, NULL,
   &redText, NULL, (APTR)&rpi, 90, (APTR)NULL
};

struct Gadget saveGadget = {&rpropGadget, 158,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &saveText, NULL, NULL,
   43, (APTR)1
};
struct Gadget loadGadget = { &saveGadget, 84,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY, BOOLGADGET, (APTR)&gImage, NULL, &loadText, NULL, NULL,
   42, (APTR)1
};   
struct Gadget showGadget = { &loadGadget, 10,6, 64,12, GADGHCOMP|GADGIMAGE,
   RELVERIFY|TOGGLESELECT, BOOLGADGET, (APTR)&gImage, NULL, &showText, NULL, NULL,
   41, (APTR)1
};
    
extern struct Window *gWindow;

VOID
mainGadgets(VOID)
{
   SetRast(gWindow->RPort, 0);
   AddGList(gWindow, &exitGadget, 0, -1, NULL);
   RefreshGList(&exitGadget, gWindow, NULL, -1);
}

VOID
fileGadgets(VOID)
{
   SetRast(gWindow->RPort, 0);
   RemoveGList(gWindow,&exitGadget, -1);
   AddGList(gWindow, &openGadget, 0, -1, NULL);
   RefreshGList(&openGadget, gWindow, NULL, -1);
}
VOID removeFileGadgets(VOID)
{
   RemoveGList(gWindow,&openGadget, -1);
}
VOID
screenGadgets(VOID)
{
   SetRast(gWindow->RPort, 0);
   RemoveGList(gWindow,&exitGadget, -1);
   AddGList(gWindow, &loresGadget, 0, -1, NULL);
   RefreshGList(&loresGadget, gWindow, NULL, -1);
}
VOID removeScreenGadgets(VOID)
{
   RemoveGList(gWindow,&loresGadget, -1);
}

VOID
paletteGadgets(VOID)
{
   SetRast(gWindow->RPort, 0);
   RemoveGList(gWindow,&exitGadget, -1);
   AddGList(gWindow, &showGadget, 0, -1, NULL);
   RefreshGList(&showGadget, gWindow, NULL, -1);
}
VOID removePaletteGadgets(VOID)
{
   RemoveGList(gWindow,&showGadget, -1);
}

VOID
turnOnGadgets(VOID)
{
   OnGadget(&paletteGadget,gWindow,NULL);
   paletteGadget.UserData = (APTR)1;
   OnGadget(&screenGadget,gWindow,NULL);
   screenGadget.UserData = (APTR)1;
   OnGadget(&psGadget,gWindow,NULL);
   psGadget.UserData = (APTR)1;
   OnGadget(&iffGadget,gWindow,NULL);
   iffGadget.UserData = (APTR)1;
   OnGadget(&nextGadget,gWindow,NULL);
   nextGadget.UserData = (APTR)1;
   SetRast(gWindow->RPort,0);
   RefreshGList(&openGadget, gWindow, NULL, -1);
}