#include <stdlib.h>
#include <exec/types.h>
#include <exec/memory.h>
#include <intuition/intuition.h>
#include <proto/graphics.h>

#include "viewprotos.h"

#include <proto/intuition.h>
#include <proto/exec.h>

struct NewWindow nw1 = {
   180, 30,
   300, 150,
   -1, 3,
   CLOSEWINDOW,
   WFLG_DRAGBAR|WFLG_DEPTHGADGET|WFLG_CLOSEGADGET,
   NULL,
   NULL,
   "About HDFView v3.01...",
   NULL,
   NULL,
   -1, -1,
   -1, -1,
   CUSTOMSCREEN
};
   

struct Window *
myCredits(struct Screen *screen, struct MsgPort *mp,int w, int h)
{
   struct Window *creditwindow;
   ULONG chipsize, fastsize;
   char buf[80];
   struct MsgPort *oldmp;
   
   struct IntuiText it = {
      1, 0,
      JAM1,
      8, 10,
      NULL,
      "HDFView: an HDF Utility Program",
      NULL
   };
   
   
   nw1.Screen = screen;
   creditwindow = OpenWindow(&nw1);
   if(creditwindow==NULL) myExit("Credit window");
   if(oldmp=creditwindow->UserPort) DeletePort(oldmp);
   creditwindow->UserPort = mp;
   
/*   SetAPen(creditwindow->RPort,0x3);
   RectFill(creditwindow->RPort,5,12,294,147);
*/   
   PrintIText(creditwindow->RPort,&it,10,20);
   it.FrontPen = 1;
   it.IText = "Freely Distributable, but...";
   PrintIText(creditwindow->RPort,&it,10,40);
   it.IText = "(c) 1991 Richard Gerber";
   PrintIText(creditwindow->RPort,&it,10,50);
   
   sprintf(buf,"Image Width: %d   Height: %d",w,h);
   it.FrontPen = 3;
   it.IText = buf;
   PrintIText(creditwindow->RPort,&it,10,80);
   
   chipsize = AvailMem(MEMF_CHIP)/1024;
   fastsize = AvailMem(MEMF_FAST)/1024;
   
   it.FrontPen = 2;
   it.IText = "Free Memory:";
   PrintIText(creditwindow->RPort,&it,10,100);
   sprintf(buf,"Graphics: %d K    Fast: %d K",chipsize, fastsize);
   it.IText = buf;
   PrintIText(creditwindow->RPort,&it,10,110);
   
   return(creditwindow);
}  
   
   
     
