#include <exec/types.h>
#include <intuition/intuition.h>
#include <proto/intuition.h>

#include "hame.h"

#include "viewprotos.h"

extern struct Window *sw;
extern struct Window *credwin;
extern struct Window *imageWindow;
extern struct Screen *imageScreen;
extern struct MsgPost *messagePort;
extern struct HamePort *hamePort;
extern BOOL isscale;
extern struct Library *HameBase;

VOID
closeDown(VOID)
{
   if(imageWindow) closeWind(imageWindow);
   
   if(sw) {
      isscale = 1;
      closeWind(sw);
   }
   sw = NULL;
   
   if(credwin)
   {
      closeWind(credwin);
   }
   credwin = NULL;
   
   if(hamePort) HAME_Dispose(hamePort);
   hamePort = NULL;
   
   if(imageScreen) CloseScreen(imageScreen);
   
}
